Subject: Re: bug#47902: cperl-mode: unwanted expansion of '$continue' [PATCH]

From: Stefan Kangas <[email-masked]>
Date: Tue, 20 Apr 2021 15:56:41 -0500

tags 47902 fixed
close 47902 28.1
thanks

[email-masked] (Harald Jörg) writes:

> The symptom: When typing "$continue", abbrev expansion kicks in and
> converts this to "$continue { }" - which immediately catches the eye as
> suddenly it is formatted as a hash access.
>
> How to reproduce from Emacs -Q:
>
>     C-x b demo.pl <RET>
>     M-: (setq cperl-electric-keywords t)
>     cperl-mode <RET>
>     $continue = 1;
>
> It is quite usual to activate 'cperl-electric-keywords', either directly
> or with the catch-all customization value 'cperl-hairy'.
>
> Root cause: The expansion routine in 'cperl-electric-else' attempts to
> verify that the keyword starts a statement, by jumping back over the
> keyword with (backward-sexp 1).  For a scalar variable "$else" or
> "$continue", this expression also skips back over the dollar (which has
> syntax type "escape" in CPerl mode), and "$continue" does start a
> statement, so unwanted expansion happens.
>
> The patch replaces (backward-sexp 1) by (skip-chars-backward "[:alpha:]")
> and avoids skipping over anything which doesn't belong to the keyword.

Thanks!  This makes sense and works fine here so I've pushed this to
master as commit c4c9a60c13.

I've made some minor adjustment of the commit message and added the bug
number.  I also added a blank line before the "ends here" line as a
minor stylistic point.